// WinTrackerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "WinTracker.h"
#include "WinTrackerDlg.h"
#include "DSObjectChooseDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWinTrackerDlg dialog

CWinTrackerDlg::CWinTrackerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CWinTrackerDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CWinTrackerDlg)
	m_StopNote = FALSE;
	m_BoucleNote = FALSE;
	m_BalEdit = _T("");
	m_PitchEdit = _T("");
	m_VolEdit = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
    isWaveOpen = FALSE; //pas de fichier ouvert
    isDSok = FALSE; //DS pas encore initialis
}

void CWinTrackerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWinTrackerDlg)
	DDX_Control(pDX, IDC_SLIDER_VOL, m_VolumeSlider);
	DDX_Control(pDX, IDC_SLIDER_PITCH, m_PitchSlider);
	DDX_Control(pDX, IDC_SLIDER_BAL, m_BalanceSlider);
	DDX_Check(pDX, IDC_STOP, m_StopNote);
	DDX_Check(pDX, IDC_BOUCLE, m_BoucleNote);
	DDX_Text(pDX, IDC_EDITBAL, m_BalEdit);
	DDX_Text(pDX, IDC_EDITPITCH, m_PitchEdit);
	DDX_Text(pDX, IDC_EDITVOL, m_VolEdit);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CWinTrackerDlg, CDialog)
	//{{AFX_MSG_MAP(CWinTrackerDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_COMMAND(ID_ABOUT, OnAbout)
	ON_WM_HSCROLL()
	ON_WM_VSCROLL()
	ON_UPDATE_COMMAND_UI(ID_FICHIER_PROPRITS, OnUpdateFichierProprits)
	ON_COMMAND(IDM_OPEN, OnOpen)
	ON_WM_SHOWWINDOW()
	ON_UPDATE_COMMAND_UI(IDM_OPEN, OnUpdateOpen)
	ON_COMMAND(ID_FICHIER_PROPRITS, OnFichierProprits)
	ON_BN_CLICKED(IDC_BUTTON_DO1, OnButtonDo1)
	ON_BN_CLICKED(IDC_BUTTON_DOD1, OnButtonDod1)
	ON_BN_CLICKED(IDC_BUTTON_RE1, OnButtonRe1)
	ON_BN_CLICKED(IDC_BUTTON_RED1, OnButtonRed1)
	ON_BN_CLICKED(IDC_BUTTON_MI1, OnButtonMi1)
	ON_BN_CLICKED(IDC_BUTTON_FA1, OnButtonFa1)
	ON_BN_CLICKED(IDC_BUTTON_FAD1, OnButtonFad1)
	ON_BN_CLICKED(IDC_BUTTON_SOL1, OnButtonSol1)
	ON_BN_CLICKED(IDC_BUTTON_SOLD1, OnButtonSold1)
	ON_BN_CLICKED(IDC_BUTTON_LA1, OnButtonLa1)
	ON_BN_CLICKED(IDC_BUTTON_LAD1, OnButtonLad1)
	ON_BN_CLICKED(IDC_BUTTON_SI1, OnButtonSi1)
	ON_BN_CLICKED(IDC_BUTTON_DO2, OnButtonDo2)
	ON_BN_CLICKED(IDC_BUTTON_DOD2, OnButtonDod2)
	ON_BN_CLICKED(IDC_BUTTON_RE2, OnButtonRe2)
	ON_BN_CLICKED(IDC_BUTTON_RED2, OnButtonRed2)
	ON_BN_CLICKED(IDC_BUTTON_MI2, OnButtonMi2)
	ON_BN_CLICKED(IDC_BUTTON_FA2, OnButtonFa2)
	ON_BN_CLICKED(IDC_BUTTON_FAD2, OnButtonFad2)
	ON_BN_CLICKED(IDC_BUTTON_SOL2, OnButtonSol2)
	ON_BN_CLICKED(IDC_BUTTON_SOLD2, OnButtonSold2)
	ON_BN_CLICKED(IDC_BUTTON_LA2, OnButtonLa2)
	ON_BN_CLICKED(IDC_BUTTON_LAD2, OnButtonLad2)
	ON_BN_CLICKED(IDC_BUTTON_SI2, OnButtonSi2)
	ON_WM_KEYDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWinTrackerDlg message handlers

BOOL CWinTrackerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}
    
	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
    SetIcon(m_hIcon, TRUE);			// Set big icon
	//SetIcon(m_hIcon, FALSE);		// Set small icon  (ne marche jamais, bug MFC)
	
	// TODO: Add extra initialization here
    //initialisation des sliders
    m_BalanceSlider.SetRange(-50, 50, TRUE);
    m_BalanceSlider.SetTicFreq(10);
    m_BalanceSlider.SetPos(0);

    m_VolumeSlider.SetRange(-100, 0, TRUE);//le slider va de haut en bas, pas naturel, faudra inverser
    m_VolumeSlider.SetTicFreq(10);
    m_VolumeSlider.SetPos(-100);//DS ne gre pas d'amplification juste une attnuation
    
    m_PitchSlider.SetRange(-50, 50, TRUE);//mme remarque
    m_PitchSlider.SetTicFreq(10);
    m_PitchSlider.SetPos(0);
	
    //initialisation des variables
    vol = 0;
    pan = 0;
    freq = 0;
        
    m_BalEdit = "0";
    m_PitchEdit = "0 %";
    m_VolEdit = "100 %";
    m_StopNote = TRUE;//non utilis encore
    m_BoucleNote = FALSE;//non utilis encore
    UpdateData(FALSE);//updater les contrles (sliders, checkboxes)
    
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CWinTrackerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CWinTrackerDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CWinTrackerDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


void CWinTrackerDlg::OnAbout() 
{
	// TODO: Add your command handler code here
    // about box
	CAboutDlg about;
    about.DoModal();
}

//actualisation des edits en fonction de la position des slides verticaux
void CWinTrackerDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// TODO: Add your message handler code here and/or call default
	m_BalEdit.Format("%d", m_BalanceSlider.GetPos());
    pan = m_BalanceSlider.GetPos();
    UpdateData(FALSE);
    ApplyControl();

	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CWinTrackerDlg::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// TODO: Add your message handler code here and/or call default
	
    m_VolEdit.Format("%d %%", -m_VolumeSlider.GetPos());
    m_PitchEdit.Format("%d %%", -m_PitchSlider.GetPos());
    vol = -m_VolumeSlider.GetPos()-100; //le vrai volume varie de -100  0 (en dB)
    freq = -m_PitchSlider.GetPos();//le slide est  l'envers
    UpdateData(FALSE);
    ApplyControl();

	CDialog::OnVScroll(nSBCode, nPos, pScrollBar);
}

void CWinTrackerDlg::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CDialog::OnShowWindow(bShow, nStatus);
	
	// TODO: Add your message handler code here

    if(!bShow) return; //si on cache, on fait rien

	// Initialisons DirectSound
    //dialogue de choix pour trouver un driver DS
    CDSObjectChooseDialog dialog;
    int result = dialog.DoModal();
    if (result != IDOK)
    {
        //on n'a pas appuy sur ok
        MessageBox("DirectSound non initialis");
        return;
    }
    
    //crons l'objet DS  partir de l'objet choisi dans la boite
    HRESULT r = DirectSoundCreate(dialog.GetDSObject(), &lpDS, NULL);
    if (r == DS_OK)
        isDSok = TRUE;
    else
    {
        //ca a foir
        MessageBox("DirectSound n'a pas pu tre initialis.", "Erreur", MB_ICONERROR);
        return;
    }
    //choisissons le niveau de partage des ressources DS
    lpDS->SetCooperativeLevel(m_hWnd, DSSCL_NORMAL);
}

void CWinTrackerDlg::OnUpdateFichierProprits(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
    /* la commande proprits doit tre dsactive si aucun
       fichier wave n'a t ouvert */
	//MessageBox("props");    
    pCmdUI->Enable(isWaveOpen);
}

void CWinTrackerDlg::OnFichierProprits() 
{
	// TODO: Add your command handler code here
    MessageBox("proprits :-)");
}

void CWinTrackerDlg::OnUpdateOpen(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	//on ne doit pas pouvoir ouvrir de fichier si DS n'est pas initialis
    pCmdUI->Enable(isDSok);
}

void CWinTrackerDlg::OnOpen() 
{
	// TODO: Add your command handler code here
	// ouverture d'un fichier wave, lecture du format itouitou
    CString filename;   //nom du fichier
    HMMIO hwav;         //handle du fichier son
    MMCKINFO pchunk;    //chunk parent
    MMCKINFO cchunk;    //sous-chunk
    WAVEFORMATEX fmt;   //format du fichier
    DSBUFFERDESC desc;  //descriptif d'un buffer DS
    char * temp;        //donnes temporaires (lues du fichier)
    char * data;        //pointeur vers les donnes du buffer DS
    

    //choix d'un fichier
    CFileDialog dialog(TRUE, NULL, NULL, OFN_FILEMUSTEXIST|OFN_HIDEREADONLY, "Fichiers Wave PCM (*.wav)|*.wav", this);
    if (dialog.DoModal() != IDOK)
        return;
    filename = dialog.GetPathName();
    //ouverture du fichier
    hwav = mmioOpen(filename.GetBuffer(0), NULL, MMIO_READ|MMIO_EXCLUSIVE);
    if (hwav == NULL)
    {
        MessageBox("Impossible d'ouvrir le fichier spcifi.", "Erreur", MB_ICONERROR);
        return;
    }
    //recherche d'un chunk wave
    pchunk.fccType = mmioFOURCC('W', 'A', 'V', 'E');
    if (mmioDescend(hwav, &pchunk, NULL, MMIO_FINDRIFF)) 
	{
		MessageBox("Le fichier ne contient pas de donnes WAVE.", "Erreur", MB_ICONERROR);
		mmioClose(hwav, 0);
        return;
	}
    //recherche d'un sous-chunk 'FMT ' (format) dans le WAVE
    cchunk.ckid = mmioFOURCC('f', 'm', 't', ' ');
    if (mmioDescend(hwav, &cchunk, &pchunk, MMIO_FINDCHUNK)) 
    {
	    MessageBox("Le fichier ne contient pas de donnes de format.", "Erreur", MB_ICONERROR);
	    mmioClose(hwav, 0);
        return;
    }
    //lecture du format audio
    if (mmioRead(hwav, (HPSTR)&fmt, cchunk.cksize) != (LONG)cchunk.cksize)
    {
        MessageBox("Impossible de lire le format du fichier.", "Erreur", MB_ICONERROR);
        mmioClose(hwav, 0);
        return;
    }
    //si format n'est pas PCM, erreur
    if (fmt.wFormatTag != WAVE_FORMAT_PCM)
    {
        MessageBox("Le fichier n'est pas au format PCM.", "Erreur", MB_ICONERROR);
        mmioClose(hwav, 0);
        return;
    }
    //recherche d'un sous-chunk DATA (donnes audio) au dessus du sous-chunk FMT 
    mmioAscend(hwav, &cchunk, 0); 
    cchunk.ckid = mmioFOURCC('d', 'a', 't', 'a');
    if (mmioDescend(hwav, &cchunk, &pchunk, MMIO_FINDCHUNK)) 
    {
        MessageBox("Le fichier ne contient pas de donnes audio.", "Erreur", MB_ICONERROR);
        mmioClose(hwav, 0);
        return;
    }
    //ne chargeons pas de fichier de taille >  ce que peut supporter DS
    if (cchunk.cksize > DSBSIZE_MAX)
    {
        MessageBox("La taille du fichier est trop importante.", "Erreur", MB_ICONERROR);
        mmioClose(hwav, 0);
        return;
    }
    
    //a partir de ce moment, si l'ouverture echoue, l'interface est dsactive
    isWaveOpen = FALSE;
    SetWindowText("WinTracker");
    
    //creons le buffer
    temp = new char[cchunk.cksize];

    //lisons le fichier... mettons tout dans le buffer
    if (mmioRead(hwav, (HPSTR)temp, cchunk.cksize) != (LONG)cchunk.cksize)
    {
        MessageBox("Taille des donnes incorrecte.", "Erreur", MB_ICONERROR);
        mmioClose(hwav, 0);
        delete [] temp;
        return;
    }
    mmioClose(hwav, 0);

    //prparons la description du buffer
    desc.dwSize = sizeof(DSBUFFERDESC);
    desc.dwFlags = DSBCAPS_CTRLDEFAULT | DSBCAPS_STATIC | DSBCAPS_GLOBALFOCUS;
    desc.lpwfxFormat = &fmt;
    desc.dwBufferBytes = cchunk.cksize;
    desc.dwReserved = 0;
    
    //frequence du morceau
    filefreq = fmt.nSamplesPerSec;

    //creation d'un buffer DS
    HRESULT hr = lpDS->CreateSoundBuffer(&desc, &soundBuffer, NULL);
    if (hr != DS_OK)
    {
        MessageBox("Impossible de crer un buffer DirectSound.", "Erreur", MB_ICONERROR);
        delete [] temp;
        return;
    } 
    
    //on locke le buffer,on recupere un pointeur, et on ecrit en mmoire les donnes du fichier
    DWORD size;
    soundBuffer->Lock(0, 0, (LPVOID *)&data, &size, NULL, NULL, DSBLOCK_ENTIREBUFFER);
    memcpy(data, temp, size);
    soundBuffer->Unlock(data, size, NULL, NULL);
    delete [] temp;
    
    SetWindowText("WinTracker - " + dialog.GetFileName());
    //un fichier est ouvert
    isWaveOpen = TRUE;
}

void CWinTrackerDlg::ApplyControl()
{
    //on ne peut appliquer les controles que si le buffer est ok
    if (!isWaveOpen) return;
    
    soundBuffer->SetPan(pan*200);       //les valeurs sont [-100000; +100000]
    soundBuffer->SetVolume(vol*100);    //[-100000; 0]
    int f1 = notefreq;
    //la frequence effective est la frequence de la note ajoute
    //au modificateur en tant pourcentage
    soundBuffer->SetFrequency(f1 + percent(f1, freq));
}

void CWinTrackerDlg::PlayNote(int rang)
{
    if (!isWaveOpen) 
	{
		if (!isDSok)
			MessageBox("DirectX n'a pas pu tre initialis.", "Erreur", MB_ICONERROR);
		else
			MessageBox("Vous devez charger un chantillon sonore.", "Wintracker", MB_ICONINFORMATION);
		return;
	}
    
    //on joue une note par rapport  son ton original, considr comme un DO
    //on construit le ton selon la gamme chromatique
    const double mul = 1.059463;
    double dfreq = 1.0;
    for (int i = 0; i < rang; i++)
        dfreq *= mul;
    notefreq = (int) ((double)(filefreq)*dfreq);
    
    ApplyControl();
    //stoppons le buffer, au cas ou il joue
    soundBuffer->Stop();
    //rewind
    soundBuffer->SetCurrentPosition(0);

    //lecture
    if (soundBuffer->Play(0, 0, 0) != DS_OK)
        MessageBox("Erreur de lecture.", "Erreur", MB_ICONERROR);
}

//pourcentage
int CWinTrackerDlg::percent(int num, int perc)
{
    return (int)((double)(num*perc)/100.0);
}

/**- Chaque touche est une note -**/

void CWinTrackerDlg::OnButtonDo1() 
{
	// TODO: Add your control notification handler code here
    PlayNote(0);
}

void CWinTrackerDlg::OnButtonDod1() 
{
	// TODO: Add your control notification handler code here
    PlayNote(1);	
}

void CWinTrackerDlg::OnButtonRe1() 
{
	// TODO: Add your control notification handler code here
	PlayNote(2);
}

void CWinTrackerDlg::OnButtonRed1() 
{
	// TODO: Add your control notification handler code here
	PlayNote(3);
}

void CWinTrackerDlg::OnButtonMi1() 
{
	// TODO: Add your control notification handler code here
	PlayNote(4);
}

void CWinTrackerDlg::OnButtonFa1() 
{
	// TODO: Add your control notification handler code here
	PlayNote(5);
}

void CWinTrackerDlg::OnButtonFad1() 
{
	// TODO: Add your control notification handler code here
	PlayNote(6);
}

void CWinTrackerDlg::OnButtonSol1() 
{
	// TODO: Add your control notification handler code here
	PlayNote(7);
}

void CWinTrackerDlg::OnButtonSold1() 
{
	// TODO: Add your control notification handler code here
	PlayNote(8);
}

void CWinTrackerDlg::OnButtonLa1() 
{
	// TODO: Add your control notification handler code here
	PlayNote(9);
}

void CWinTrackerDlg::OnButtonLad1() 
{
	// TODO: Add your control notification handler code here
	PlayNote(10);
}

void CWinTrackerDlg::OnButtonSi1() 
{
	// TODO: Add your control notification handler code here
	PlayNote(11);
}

void CWinTrackerDlg::OnButtonDo2() 
{
	// TODO: Add your control notification handler code here
	PlayNote(12);
}

void CWinTrackerDlg::OnButtonDod2() 
{
	// TODO: Add your control notification handler code here
	PlayNote(13);
}

void CWinTrackerDlg::OnButtonRe2() 
{
	// TODO: Add your control notification handler code here
	PlayNote(14);
}

void CWinTrackerDlg::OnButtonRed2() 
{
	// TODO: Add your control notification handler code here
	PlayNote(15);
}

void CWinTrackerDlg::OnButtonMi2() 
{
	// TODO: Add your control notification handler code here
	PlayNote(16);
}

void CWinTrackerDlg::OnButtonFa2() 
{
	// TODO: Add your control notification handler code here
	PlayNote(17);
}

void CWinTrackerDlg::OnButtonFad2() 
{
	// TODO: Add your control notification handler code here
	PlayNote(18);
}

void CWinTrackerDlg::OnButtonSol2() 
{
	// TODO: Add your control notification handler code here
	PlayNote(19);
}

void CWinTrackerDlg::OnButtonSold2() 
{
	// TODO: Add your control notification handler code here
	PlayNote(20);
}

void CWinTrackerDlg::OnButtonLa2() 
{
	// TODO: Add your control notification handler code here
	PlayNote(21);
}

void CWinTrackerDlg::OnButtonLad2() 
{
	// TODO: Add your control notification handler code here
	PlayNote(22);
}

void CWinTrackerDlg::OnButtonSi2() 
{
	// TODO: Add your control notification handler code here
	PlayNote(23);
}

void CWinTrackerDlg::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	// TODO: Add your message handler code here and/or call default
    //if (nFlags & 0x4000) return;

    switch (nChar)
    {
    case VK_SPACE : PlayNote(7);
    default : break;
    }

	//CDialog::OnKeyDown(nChar, nRepCnt, nFlags);
}
