#if !defined(AFX_DSOBJECTCHOOSEDIALOG_H__13D5959D_2BD2_4BF0_B0F7_BB8A23115BC6__INCLUDED_)
#define AFX_DSOBJECTCHOOSEDIALOG_H__13D5959D_2BD2_4BF0_B0F7_BB8A23115BC6__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// DSObjectChooseDialog.h : header file
//

//fonction de callback pour numrer les objets DirectSound
BOOL CALLBACK DSEnumCallback(
  LPGUID lpGuid,            
  LPCSTR lpcstrDescription,  
  LPCSTR lpcstrModule,       
  LPVOID lpContext          
);

/////////////////////////////////////////////////////////////////////////////
// CDSObjectChooseDialog dialog

class CDSObjectChooseDialog : public CDialog
{
// Construction
public:
	LPGUID GetDSObject();
	CDSObjectChooseDialog(CWnd* pParent = NULL);   // standard constructor
	CPtrList m_GUIDList;        //liste des GUID des objets DS ( ~= CLSID ) ex : { 13D5959D 2BD2 4BF0 B0F7 BB8A23115BC6 }
// Dialog Data
	//{{AFX_DATA(CDSObjectChooseDialog)
	enum { IDD = IDD_DSOBJECT_CHOOSE };
	CButton	m_okbtn;
	CListBox	m_ObjectList;
	CString	m_CurrentObject;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDSObjectChooseDialog)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
    LPGUID the_GUID; //le GUID slectionn
	// Generated message map functions
	//{{AFX_MSG(CDSObjectChooseDialog)
	afx_msg void OnShowWindow(BOOL bShow, UINT nStatus);
	afx_msg void OnSelchangeList1();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DSOBJECTCHOOSEDIALOG_H__13D5959D_2BD2_4BF0_B0F7_BB8A23115BC6__INCLUDED_)
